#!/usr/bin/perl
#
# $RCSfile: img2iw44.plx,v $
# $Author: swaj $
# $Revision: 1.1.2.2 $
#

use 5.008;
use strict;
no warnings;

my $convert = '/usr/local/bin/convert';
my $cjb2    = '/usr/local/djvu/bin/cjb2';
my $c44     = '/usr/local/djvu/bin/c44';

my $c44_parms = q{};
$c44_parms  = '-slice 99 -crcbhalf -crcbdelay 20';


$|++;
my $tmp_templ = "/tmp/$$-temp";

for ( ($convert, $cjb2, $c44) )
{
    die "Executable '$_' not found\n" unless (-x);
}


die "Usage: $0 file1 ...\n" unless @ARGV;

my $out_file = q{};
my $tmp1 = q{};

for (@ARGV)
{
    print "Process file '$_'... ";
    if (! -s || !-f) {
	print "not found\n";
	next;
    }

    if ( ! /png$/i  && ! /gif$/i && ! /jp.?g$/i ) {
	print "bad format\n";
	next;
    }

    $tmp1 = $tmp_templ . '.ppm'; 
    system ("$convert $_ $tmp1");

    unless (-s $tmp1) {
	print "failed ($tmp1)\n";
	next;
    }

    $out_file = $_;
    $out_file =~ s|^(.*)\.\S+$|$1.djvu|;

    unlink $out_file;
    system ("$c44 $c44_parms $tmp1 $out_file");
    unlink ($tmp1);

    unless (-s $out_file) {
	print "failed (djvu)\n";
	next;
    }

    print "OK\n";
}

print "All done!\n";
exit 0;



__END__
